/**
 * @name string-extract-class-names
 * @fileoverview Extracts CSS class/id names from a string
 * @version 8.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-extract-class-names/}
 */

"use strict";var stringExtractClassNames=(()=>{var kt=Object.create;var E=Object.defineProperty;var Kt=Object.getOwnPropertyDescriptor;var qt=Object.getOwnPropertyNames;var Qt=Object.getPrototypeOf,Jt=Object.prototype.hasOwnProperty;var Zt=(t,e)=>()=>(e||t((e={exports:{}}).exports,e),e.exports),Xt=(t,e)=>{for(var r in e)E(t,r,{get:e[r],enumerable:!0})},et=(t,e,r,n)=>{if(e&&typeof e=="object"||typeof e=="function")for(let i of qt(e))!Jt.call(t,i)&&i!==r&&E(t,i,{get:()=>e[i],enumerable:!(n=Kt(e,i))||n.enumerable});return t};var Yt=(t,e,r)=>(r=t!=null?kt(Qt(t)):{},et(e||!t||!t.__esModule?E(r,"default",{value:t,enumerable:!0}):r,t)),zt=t=>et(E({},"__esModule",{value:!0}),t);var Ut=Zt((S,y)=>{var te=200,dt="__lodash_hash_undefined__",ht=9007199254740991,K="[object Arguments]",ee="[object Array]",gt="[object Boolean]",mt="[object Date]",re="[object Error]",q="[object Function]",bt="[object GeneratorFunction]",O="[object Map]",yt="[object Number]",Q="[object Object]",rt="[object Promise]",At="[object RegExp]",j="[object Set]",_t="[object String]",wt="[object Symbol]",V="[object WeakMap]",vt="[object ArrayBuffer]",D="[object DataView]",St="[object Float32Array]",xt="[object Float64Array]",Ct="[object Int8Array]",$t="[object Int16Array]",Tt="[object Int32Array]",Et="[object Uint8Array]",Ot="[object Uint8ClampedArray]",jt="[object Uint16Array]",Dt="[object Uint32Array]",ne=/[\\^$.*+?()[\]{}|]/g,ie=/\w*$/,se=/^\[object .+?Constructor\]$/,oe=/^(?:0|[1-9]\d*)$/,o={};o[K]=o[ee]=o[vt]=o[D]=o[gt]=o[mt]=o[St]=o[xt]=o[Ct]=o[$t]=o[Tt]=o[O]=o[yt]=o[Q]=o[At]=o[j]=o[_t]=o[wt]=o[Et]=o[Ot]=o[jt]=o[Dt]=!0;o[re]=o[q]=o[V]=!1;var ae=typeof global=="object"&&global&&global.Object===Object&&global,ue=typeof self=="object"&&self&&self.Object===Object&&self,p=ae||ue||Function("return this")(),Rt=typeof S=="object"&&S&&!S.nodeType&&S,nt=Rt&&typeof y=="object"&&y&&!y.nodeType&&y,le=nt&&nt.exports===Rt;function ce(t,e){return t.set(e[0],e[1]),t}function fe(t,e){return t.add(e),t}function pe(t,e){for(var r=-1,n=t?t.length:0;++r<n&&e(t[r],r,t)!==!1;);return t}function de(t,e){for(var r=-1,n=e.length,i=t.length;++r<n;)t[i+r]=e[r];return t}function Nt(t,e,r,n){var i=-1,a=t?t.length:0;for(n&&a&&(r=t[++i]);++i<a;)r=e(r,t[i],i,t);return r}function he(t,e){for(var r=-1,n=Array(t);++r<t;)n[r]=e(r);return n}function ge(t,e){return t==null?void 0:t[e]}function It(t){var e=!1;if(t!=null&&typeof t.toString!="function")try{e=!!(t+"")}catch(r){}return e}function it(t){var e=-1,r=Array(t.size);return t.forEach(function(n,i){r[++e]=[i,n]}),r}function J(t,e){return function(r){return t(e(r))}}function st(t){var e=-1,r=Array(t.size);return t.forEach(function(n){r[++e]=n}),r}var me=Array.prototype,be=Function.prototype,R=Object.prototype,F=p["__core-js_shared__"],ot=function(){var t=/[^.]+$/.exec(F&&F.keys&&F.keys.IE_PROTO||"");return t?"Symbol(src)_1."+t:""}(),Lt=be.toString,h=R.hasOwnProperty,N=R.toString,ye=RegExp("^"+Lt.call(h).replace(ne,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),at=le?p.Buffer:void 0,ut=p.Symbol,lt=p.Uint8Array,Ae=J(Object.getPrototypeOf,Object),_e=Object.create,we=R.propertyIsEnumerable,ve=me.splice,ct=Object.getOwnPropertySymbols,Se=at?at.isBuffer:void 0,xe=J(Object.keys,Object),W=w(p,"DataView"),x=w(p,"Map"),H=w(p,"Promise"),U=w(p,"Set"),G=w(p,"WeakMap"),C=w(Object,"create"),Ce=b(W),$e=b(x),Te=b(H),Ee=b(U),Oe=b(G),ft=ut?ut.prototype:void 0,pt=ft?ft.valueOf:void 0;function m(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function je(){this.__data__=C?C(null):{}}function De(t){return this.has(t)&&delete this.__data__[t]}function Re(t){var e=this.__data__;if(C){var r=e[t];return r===dt?void 0:r}return h.call(e,t)?e[t]:void 0}function Ne(t){var e=this.__data__;return C?e[t]!==void 0:h.call(e,t)}function Ie(t,e){var r=this.__data__;return r[t]=C&&e===void 0?dt:e,this}m.prototype.clear=je;m.prototype.delete=De;m.prototype.get=Re;m.prototype.has=Ne;m.prototype.set=Ie;function d(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function Le(){this.__data__=[]}function Be(t){var e=this.__data__,r=I(e,t);if(r<0)return!1;var n=e.length-1;return r==n?e.pop():ve.call(e,r,1),!0}function Pe(t){var e=this.__data__,r=I(e,t);return r<0?void 0:e[r][1]}function Me(t){return I(this.__data__,t)>-1}function Fe(t,e){var r=this.__data__,n=I(r,t);return n<0?r.push([t,e]):r[n][1]=e,this}d.prototype.clear=Le;d.prototype.delete=Be;d.prototype.get=Pe;d.prototype.has=Me;d.prototype.set=Fe;function A(t){var e=-1,r=t?t.length:0;for(this.clear();++e<r;){var n=t[e];this.set(n[0],n[1])}}function Ve(){this.__data__={hash:new m,map:new(x||d),string:new m}}function We(t){return L(this,t).delete(t)}function He(t){return L(this,t).get(t)}function Ue(t){return L(this,t).has(t)}function Ge(t,e){return L(this,t).set(t,e),this}A.prototype.clear=Ve;A.prototype.delete=We;A.prototype.get=He;A.prototype.has=Ue;A.prototype.set=Ge;function _(t){this.__data__=new d(t)}function ke(){this.__data__=new d}function Ke(t){return this.__data__.delete(t)}function qe(t){return this.__data__.get(t)}function Qe(t){return this.__data__.has(t)}function Je(t,e){var r=this.__data__;if(r instanceof d){var n=r.__data__;if(!x||n.length<te-1)return n.push([t,e]),this;r=this.__data__=new A(n)}return r.set(t,e),this}_.prototype.clear=ke;_.prototype.delete=Ke;_.prototype.get=qe;_.prototype.has=Qe;_.prototype.set=Je;function Ze(t,e){var r=X(t)||_r(t)?he(t.length,String):[],n=r.length,i=!!n;for(var a in t)(e||h.call(t,a))&&!(i&&(a=="length"||mr(a,n)))&&r.push(a);return r}function Bt(t,e,r){var n=t[e];(!(h.call(t,e)&&Vt(n,r))||r===void 0&&!(e in t))&&(t[e]=r)}function I(t,e){for(var r=t.length;r--;)if(Vt(t[r][0],e))return r;return-1}function Xe(t,e){return t&&Pt(e,Y(e),t)}function k(t,e,r,n,i,a,l){var s;if(n&&(s=a?n(t,i,a,l):n(t)),s!==void 0)return s;if(!B(t))return t;var $=X(t);if($){if(s=dr(t),!e)return cr(t,s)}else{var c=g(t),f=c==q||c==bt;if(vr(t))return nr(t,e);if(c==Q||c==K||f&&!a){if(It(t))return a?t:{};if(s=hr(f?{}:t),!e)return fr(t,Xe(s,t))}else{if(!o[c])return a?t:{};s=gr(t,c,k,e)}}l||(l=new _);var z=l.get(t);if(z)return z;if(l.set(t,s),!$)var tt=r?pr(t):Y(t);return pe(tt||t,function(M,T){tt&&(T=M,M=t[T]),Bt(s,T,k(M,e,r,n,T,t,l))}),s}function Ye(t){return B(t)?_e(t):{}}function ze(t,e,r){var n=e(t);return X(t)?n:de(n,r(t))}function tr(t){return N.call(t)}function er(t){if(!B(t)||yr(t))return!1;var e=Ht(t)||It(t)?ye:se;return e.test(b(t))}function rr(t){if(!Ft(t))return xe(t);var e=[];for(var r in Object(t))h.call(t,r)&&r!="constructor"&&e.push(r);return e}function nr(t,e){if(e)return t.slice();var r=new t.constructor(t.length);return t.copy(r),r}function Z(t){var e=new t.constructor(t.byteLength);return new lt(e).set(new lt(t)),e}function ir(t,e){var r=e?Z(t.buffer):t.buffer;return new t.constructor(r,t.byteOffset,t.byteLength)}function sr(t,e,r){var n=e?r(it(t),!0):it(t);return Nt(n,ce,new t.constructor)}function or(t){var e=new t.constructor(t.source,ie.exec(t));return e.lastIndex=t.lastIndex,e}function ar(t,e,r){var n=e?r(st(t),!0):st(t);return Nt(n,fe,new t.constructor)}function ur(t){return pt?Object(pt.call(t)):{}}function lr(t,e){var r=e?Z(t.buffer):t.buffer;return new t.constructor(r,t.byteOffset,t.length)}function cr(t,e){var r=-1,n=t.length;for(e||(e=Array(n));++r<n;)e[r]=t[r];return e}function Pt(t,e,r,n){r||(r={});for(var i=-1,a=e.length;++i<a;){var l=e[i],s=n?n(r[l],t[l],l,r,t):void 0;Bt(r,l,s===void 0?t[l]:s)}return r}function fr(t,e){return Pt(t,Mt(t),e)}function pr(t){return ze(t,Y,Mt)}function L(t,e){var r=t.__data__;return br(e)?r[typeof e=="string"?"string":"hash"]:r.map}function w(t,e){var r=ge(t,e);return er(r)?r:void 0}var Mt=ct?J(ct,Object):Cr,g=tr;(W&&g(new W(new ArrayBuffer(1)))!=D||x&&g(new x)!=O||H&&g(H.resolve())!=rt||U&&g(new U)!=j||G&&g(new G)!=V)&&(g=function(t){var e=N.call(t),r=e==Q?t.constructor:void 0,n=r?b(r):void 0;if(n)switch(n){case Ce:return D;case $e:return O;case Te:return rt;case Ee:return j;case Oe:return V}return e});function dr(t){var e=t.length,r=t.constructor(e);return e&&typeof t[0]=="string"&&h.call(t,"index")&&(r.index=t.index,r.input=t.input),r}function hr(t){return typeof t.constructor=="function"&&!Ft(t)?Ye(Ae(t)):{}}function gr(t,e,r,n){var i=t.constructor;switch(e){case vt:return Z(t);case gt:case mt:return new i(+t);case D:return ir(t,n);case St:case xt:case Ct:case $t:case Tt:case Et:case Ot:case jt:case Dt:return lr(t,n);case O:return sr(t,n,r);case yt:case _t:return new i(t);case At:return or(t);case j:return ar(t,n,r);case wt:return ur(t)}}function mr(t,e){return e=e==null?ht:e,!!e&&(typeof t=="number"||oe.test(t))&&t>-1&&t%1==0&&t<e}function br(t){var e=typeof t;return e=="string"||e=="number"||e=="symbol"||e=="boolean"?t!=="__proto__":t===null}function yr(t){return!!ot&&ot in t}function Ft(t){var e=t&&t.constructor,r=typeof e=="function"&&e.prototype||R;return t===r}function b(t){if(t!=null){try{return Lt.call(t)}catch(e){}try{return t+""}catch(e){}}return""}function Ar(t){return k(t,!0,!0)}function Vt(t,e){return t===e||t!==t&&e!==e}function _r(t){return wr(t)&&h.call(t,"callee")&&(!we.call(t,"callee")||N.call(t)==K)}var X=Array.isArray;function Wt(t){return t!=null&&Sr(t.length)&&!Ht(t)}function wr(t){return xr(t)&&Wt(t)}var vr=Se||$r;function Ht(t){var e=B(t)?N.call(t):"";return e==q||e==bt}function Sr(t){return typeof t=="number"&&t>-1&&t%1==0&&t<=ht}function B(t){var e=typeof t;return!!t&&(e=="object"||e=="function")}function xr(t){return!!t&&typeof t=="object"}function Y(t){return Wt(t)?Ze(t):rr(t)}function Cr(){return[]}function $r(){return!1}y.exports=Ar});var Nr={};Xt(Nr,{extract:()=>Rr,version:()=>Dr});var Tr=Yt(Ut(),1);var v="\xA0";function Er({str:t,idx:e=0,stopAtNewlines:r=!1,stopAtRawNbsp:n=!1}){if(typeof t!="string"||!t.length||((!e||typeof e!="number")&&(e=0),!t[e+1]))return null;if(t[e+1]&&(t[e+1].trim()||r&&`
\r`.includes(t[e+1])||n&&t[e+1]===v))return e+1;if(t[e+2]&&(t[e+2].trim()||r&&`
\r`.includes(t[e+2])||n&&t[e+2]===v))return e+2;for(let i=e+1,a=t.length;i<a;i++)if(t[i].trim()||r&&`
\r`.includes(t[i])||n&&t[i]===v)return i;return null}function u(t,e=0){return Er({str:t,idx:e,stopAtNewlines:!1,stopAtRawNbsp:!1})}function Or({str:t,idx:e,stopAtNewlines:r,stopAtRawNbsp:n}){if(typeof t!="string"||!t.length||((!e||typeof e!="number")&&(e=0),e<1))return null;if(t[~-e]&&(t[~-e].trim()||r&&`
\r`.includes(t[~-e])||n&&t[~-e]===v))return~-e;if(t[e-2]&&(t[e-2].trim()||r&&`
\r`.includes(t[e-2])||n&&t[e-2]===v))return e-2;for(let i=e;i--;)if(t[i]&&(t[i].trim()||r&&`
\r`.includes(t[i])||n&&t[i]===v))return i;return null}function P(t,e=0){return Or({str:t,idx:e,stopAtNewlines:!1,stopAtRawNbsp:!1})}var Gt="8.0.9";var Dr=Gt;function Rr(t){var l;if(typeof t!="string")throw new TypeError(`string-extract-class-names: [THROW_ID_01] first str should be string, not ${typeof t}, currently equal to ${JSON.stringify(t,null,4)}`);let e=".# ~\\!@$%^&*()+=,/';:\"?><[]{}|`",r;function n(s){return typeof s=="string"&&!!s.length&&(s.charCodeAt(0)>64&&s.charCodeAt(0)<91||s.charCodeAt(0)>96&&s.charCodeAt(0)<123)}let i=null,a={res:[],ranges:[]};for(let s=0,$=t.length;s<=$;s++){i!==null&&s>=i&&(!((l=t[s])!=null&&l.trim())||e.includes(t[s]))&&(s>i+1&&(a.ranges.push([i,s]),a.res.push(`${r||""}${t.slice(i,s)}`),r&&(r=void 0)),i=null),t[s]&&i===null&&(t[s]==="."||t[s]==="#")&&(i=s);let c=u(t,s+4);t.startsWith("class",s)&&typeof P(t,s)=="number"&&t[P(t,s)]==="["&&typeof c=="number"&&t[c]==="="&&(u(t,c)&&n(t[u(t,c)])?i=u(t,c):`'"`.includes(t[u(t,c)])&&n(t[u(t,u(t,c))])&&(i=u(t,u(t,c))),r=".");let f=u(t,s+1);t.startsWith("id",s)&&t[P(t,s)]==="["&&f!==null&&t[f]==="="&&(n(t[u(t,f)])?i=u(t,f):`'"`.includes(t[u(t,f)])&&n(t[u(t,u(t,f))])&&(i=u(t,u(t,f))),r="#")}return a.ranges.length||(a.ranges=null),a}return zt(Nr);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.3.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name string-left-right
 * @fileoverview Looks up the first non-whitespace character to the left/right of a given index
 * @version 6.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-left-right/}
 */
